// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef SENSOR_HH
#define SENSOR_HH

#include <cstddef>
#include <stdint.h>

class sensor
{

public:

    bool sensor_low_old;
    bool sensor_high_old;
    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct sensor_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;
        bool * sensor_high;
        bool * sensor_low;

        sensor_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr),
            sensor_high(nullptr),
            sensor_low(nullptr)
        {}

        sensor_iostruct( bool * pclk_5, bool * presetn_5, uint32_t * paddr_5, bool
             * psel_5, bool * penable_5, bool * pwrite_5, uint32_t * pwdata_5, bool
             * pready_5, uint32_t * prdata_5, bool * sensor_high_0, bool * sensor_low_0
             ):
            pclk(pclk_5),
            presetn(presetn_5),
            paddr(paddr_5),
            psel(psel_5),
            penable(penable_5),
            pwrite(pwrite_5),
            pwdata(pwdata_5),
            pready(pready_5),
            prdata(prdata_5),
            sensor_high(sensor_high_0),
            sensor_low(sensor_low_0)
        {}

        ~sensor_iostruct()
        {}

        bool operator == (const sensor_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            if (sensor_high != other.sensor_high) return false;
            if (sensor_low != other.sensor_low) return false;
            return true;
        }
    };
    sensor_iostruct hif_a2t_data;
    uint32_t prdata_var_1;
    sensor();


    ~sensor();


    bool process_in_queue;
    bool flag_pos_pclk;

    void process();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    sensor( const sensor & );
    const sensor& operator= ( const sensor & );


};


#endif

